<script setup>
    const props = defineProps({
        name : {
            type: String,
            required: true
        },
        is_selected : {
            type: Boolean,
            required: true
        },
        taille: {
            type: Number,
            default: NaN
        }
    });

    const dimensionCSS = computed (() => {
        let value ='';
        const lettreWidth=9;
        const lettreHeight=24;

        if (Number.isInteger(props.taille)){
            value=' max-width: '+(props.taille*lettreWidth+16+lettreWidth+((props.name.length>props.taille)?3*lettreWidth:0))+'px; max-height: '+lettreHeight+'px'
        }

        return value;
    });

    const tooltipClass = computed (() => {

        if (Number.isInteger(props.taille)){
            if (props.name.length>props.taille){
                return " relative before:absolute before:top-0 before:leading-3 before:w-full before:overflow-x-scroll before:overflow-y-hidden  before:text-nowrap before:opacity-0 before:content-[attr(tooltip-data)] before:bg-white before:text-black before:border before:border-slate-200 before:rounded-md before:z-50 hover:before:opacity-100 hover:cursor-pointer ";
            }
        }

        return " hover:cursor-pointer";

    });
    
    const textAfficher = computed (() => {
        let value=props.name;

        if (Number.isInteger(props.taille)){
            if (props.name.length>props.taille){
                value=props.name.substring(0,props.taille)+"...";
            }
        }

        return value;
    });
    const emit = defineEmits(["select"])

    const li_class = computed(() => {
        if(props.is_selected) {
            return "text-black bg-white rounded-lg hover:cursor-pointer";
        }
        else {
            return "text-white hover:cursor-pointer hover:text-black hover:bg-white hover:rounded-lg";
        }
    });

    function emitSelect() {
        if(props.is_selected) {
            emit("select", false);
        }
        else {
            emit("select", true);
        }
    }

</script>
<template>
    <li @click="emitSelect" :tooltip-data="name" :style="dimensionCSS" :class="li_class+tooltipClass">        
        {{ textAfficher }}
    </li>
</template>